#ifdef GL_EXT_draw_buffers
#extension GL_EXT_draw_buffers : enable
#endif
precision mediump float;uniform vec2 uVolumeTilingSize;uniform vec3 uVolumeSize;
#ifndef QUALITY
#define QUALITY 0
#endif
#if 0==QUALITY
#define STEPS 32
#define LOW_QUALITY 1
#elif 1==QUALITY
#define STEPS 64
#elif 2==QUALITY
#define STEPS 128
#define HIGH_QUALITY 1
#elif 3==QUALITY
#define STEPS 265
#define HIGH_QUALITY 1
#else
#error Invalid value for QUALITY
#endif
#if 8==LABEL_DEPTH
#define LABEL_MAX 255.0
float colorToIndex(vec4 color) {return color.r*LABEL_MAX;}
vec2 colorToIndexV(vec4 color) {return vec2(color.r,0);}
float indexVToIndex(vec2 index) {return index.x*LABEL_MAX;}
#elif 16==LABEL_DEPTH
#define LABEL_MAX 65535.0
float colorToIndex(vec4 color) {return color.r*255.0+floor(color.a*256.0)*256.0;}
vec2 colorToIndexV(vec4 color) {return vec2(color.r,color.a);}
float indexVToIndex(vec2 index) {return index.x*255.0+floor(index.y*256.0)*256.0;}
#else
#error Unknown LABEL_DEPTH
#endif
highp float rand(highp vec2 co){return fract(sin(dot(co.xy,vec2(12.9898,78.233)))*43758.5453);}
highp float rand(highp vec3 co){return fract(sin(dot(co,vec3(12.9898,78.233,34.897)))*43758.5453);}
highp float BBSstate;const highp float BBSM=11.0*19.0;float BBShash(highp float x) {return mod(x*x,BBSM);}
void initBBS(highp float seed) {BBSstate=3.0+floor(mod(seed,BBSM-4.0));}
void initBBS(highp vec3 seed) {initBBS(floor(BBSM*rand(seed)));}
float BBS() {BBSstate=BBShash(BBSstate);return BBSstate/BBSM;}
vec3 randomUnitVector() {const highp float tau=6.283185307179586;highp float x=tau*BBS();highp float y=2.0*BBS()-1.0;highp float rXY=sqrt(1.0-y*y);return vec3(rXY*cos(x),rXY*sin(x),y);}
vec4 lutRGBA(sampler2D lut,float length,float index) {return texture2D(lut,vec2((index+0.5)/length,0.5));}
uniform sampler2D uIntensityLUT;vec4 intensityToColor(float intensity) {const float lutLength=256.0;return texture2D(uIntensityLUT,vec2((1.0-1.0/lutLength)*intensity+0.5/lutLength,0.5));}
uniform vec2 uViewportOrigin;
#define FB_TEXTURE_COORDS ((gl_FragCoord.xy-uViewportOrigin)/uViewportSize)
#define FRONT_COORDS texture2D(uFrontCoords,FB_TEXTURE_COORDS).xyz
#define PREVIOUS_FRAG_COLOR texture2D(uPreviousStage,FB_TEXTURE_COORDS)
#define LABEL_FRAG_COORD FB_TEXTURE_COORDS
#define LABEL_PREVIOUS_FRAG_COLOR PREVIOUS_FRAG_COLOR
#define LABEL_FRONT_COORDS FRONT_COORDS
#define SAMPLER_3D sampler2D
highp vec2 tileCoord(highp float slice) {highp vec2 sliceCoord;slice+=0.5;sliceCoord.y=floor(slice/uVolumeTilingSize.x);sliceCoord.x=floor(slice-uVolumeTilingSize.x*sliceCoord.y);return sliceCoord;}
float texelCoord(float coord,float textureSize) {float texelSize=1.0/textureSize;return (coord-0.5*texelSize)*textureSize;}
lowp vec4 texture3DNearest(SAMPLER_3D texture,highp vec3 coord) {highp float slice=floor(texelCoord(coord.z,uVolumeSize.z)+0.5);return texture2D(texture,(tileCoord(slice)+coord.xy)/uVolumeTilingSize);}
lowp vec4 texture3D(SAMPLER_3D texture,highp vec3 coord) {vec3 voxelSize=1.0/uVolumeSize;vec3 clampMax=1.0-0.5*voxelSize;vec3 clampMin=0.5*voxelSize;coord=clamp(coord,clampMin,clampMax);highp float slice=texelCoord(coord.z,uVolumeSize.z);highp float slice1=floor(slice);vec4 sliceColor1=texture2D(texture,(tileCoord(slice1)+coord.xy)/uVolumeTilingSize);highp float slice2=slice1+1.0;vec4 sliceColor2=texture2D(texture,(tileCoord(slice2)+coord.xy)/uVolumeTilingSize);return mix(sliceColor1,sliceColor2,fract(slice));}
#ifdef HIGH_QUALITY
#define TEXTURE_3D_LUT texture3DLinearLUT
#else
#define TEXTURE_3D_LUT texture3DNearestLUT
#endif
#ifdef LOW_QUALITY
#define TEXTURE_3D texture3DNearest
#else
#define TEXTURE_3D texture3D
#endif
vec4 texture3DNearestLUT(SAMPLER_3D texture,vec3 coord,sampler2D LUT,float LUTLength)
{float index=colorToIndex(texture3DNearest(texture,coord));return lutRGBA(LUT,LUTLength,index);}
vec4 texture3DLinearLUT(SAMPLER_3D texture,vec3 coord,sampler2D LUT,float LUTLength)
{vec3 pixelPosition=(uVolumeSize-1.0)*coord;vec3 low=(floor(pixelPosition)+0.5)/uVolumeSize;vec3 high=(ceil(pixelPosition)+0.5)/uVolumeSize;mediump vec4 lowColor=texture3DNearestLUT(texture,low,LUT,LUTLength);vec4 color=mix(lowColor,texture3DNearestLUT(texture,vec3(high.x,low.yz),LUT,LUTLength),fract(pixelPosition.x));color+=mix(lowColor,texture3DNearestLUT(texture,vec3(low.x,high.y,low.z),LUT,LUTLength),fract(pixelPosition.y));color+=mix(lowColor,texture3DNearestLUT(texture,vec3(low.xy,high.z),LUT,LUTLength),fract(pixelPosition.z));return color/3.0;}
